# coding: utf-8

"""
    Klaviyo API

    The Klaviyo REST API. Please visit https://developers.klaviyo.com for more details.

    Contact: developers@klaviyo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ListRetrieveResponseObjectResourceExtendedAttributes(BaseModel):
    """
    ListRetrieveResponseObjectResourceExtendedAttributes
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="A helpful name to label the list")
    created: Optional[datetime] = Field(default=None, description="Date and time when the list was created, in ISO 8601 format (YYYY-MM-DDTHH:MM:SS.mmmmmm)")
    updated: Optional[datetime] = Field(default=None, description="Date and time when the list was last updated, in ISO 8601 format (YYYY-MM-DDTHH:MM:SS.mmmmmm)")
    opt_in_process: Optional[StrictStr] = Field(default=None, description="The opt-in process for this list.  Could be either 'single_opt_in' or 'double_opt_in'.")
    profile_count: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["name", "created", "updated", "opt_in_process", "profile_count"]

    @field_validator('opt_in_process')
    def opt_in_process_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['double_opt_in', 'single_opt_in']):
            raise ValueError("must be one of enum values ('double_opt_in', 'single_opt_in')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListRetrieveResponseObjectResourceExtendedAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if created (nullable) is None
        # and model_fields_set contains the field
        if self.created is None and "created" in self.model_fields_set:
            _dict['created'] = None

        # set to None if updated (nullable) is None
        # and model_fields_set contains the field
        if self.updated is None and "updated" in self.model_fields_set:
            _dict['updated'] = None

        # set to None if opt_in_process (nullable) is None
        # and model_fields_set contains the field
        if self.opt_in_process is None and "opt_in_process" in self.model_fields_set:
            _dict['opt_in_process'] = None

        # set to None if profile_count (nullable) is None
        # and model_fields_set contains the field
        if self.profile_count is None and "profile_count" in self.model_fields_set:
            _dict['profile_count'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListRetrieveResponseObjectResourceExtendedAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "created": obj.get("created"),
            "updated": obj.get("updated"),
            "opt_in_process": obj.get("opt_in_process"),
            "profile_count": obj.get("profile_count")
        })
        return _obj


